<?php
/*
# ------------------------------------------------------------------------
# JA News Light module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license - PHP files are GNU/GPL V2. CSS / JS are Copyrighted Commercial,
# bound by Proprietary License of JoomlArt. For details on licensing, 
# Please Read Terms of Use at http://www.joomlart.com/terms_of_use.html.
# Author: JoomlArt.com
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# Redistribution, Modification or Re-licensing of this file in part of full, 
# is bound by the License applied. 
# ------------------------------------------------------------------------
*/

class JA_News {
	function replaceImage( &$row, $maxchars, $showimage, $width = 0, $height = 0 ) {

		// expression to search for
		$regex = '/{mosimage\s*.*?}/i';

		$image = $showimage?JA_News::processImage ( $row, $width, $height ):"";

		if ($image) {
			$row->introtext = trim($row->introtext);
			$row->introtext = preg_replace( $regex, '', $row->introtext );
		} else {
			$regex = "/\<img.*\/\>/";
			preg_match ($regex, $row->introtext, $matches);
			$row->introtext = trim($row->introtext);
			$row->introtext = preg_replace ($regex, '', $row->introtext);

			$image = $showimage && count($matches)?$matches[0]:"";
			if ($image) {
				if ($width) {
					if (is_numeric ($width)) $width = $width;
					$regex = '/(width\s*=\s*\"?)([^\s,^\"]*)/';
					if (preg_match ($regex, $image))
						$image = preg_replace ($regex, '${1}'.$width, $image);
					else {
						$image = substr ($image, 0, -2) . " width=\"$width\" />";
					}
				}
				if ($height) {
					if (is_numeric ($height)) $height = $height;
					$regex = '/(height\s*=\s*\"?)([^\s,^\"]*)/';
					if (preg_match ($regex, $image))
						$image = preg_replace ($regex, '${1}'.$height, $image);
					else {
						$image = substr ($image, 0, -2) . " style=\"heigh:$height\" />";
					}
				}
			}
		}

		$row->introtext1 = strip_tags($row->introtext);
		if ($maxchars && strlen ($row->introtext) > $maxchars) {
			$row->introtext1 = substr ($row->introtext1, 0, $maxchars) . "...";
		}
		// clean up globals
		return $image;
	}

	function processImage ( &$row, $width, $height ) {
		/* for 1.5 - don't need to use image parameter */
		return 0;
		/* End 1.5 */
	}

	function calModStyle ($cols) {
		$modules = array();
		switch ($cols) {
			case 0: return null;
			break;
			case 1:
				$modules[0]['class'] = "";
				$modules[0]['width'] = "100%";
				$modules[0]['subwidth'] = "100%";
				break;
			case 2:
				$modules[0]['class'] = "-left";
				$modules[0]['width'] = "49.9%";
				$modules[0]['subwidth'] = "95%";
				$modules[1]['class'] = "-right";
				$modules[1]['width'] = "49.9%";
				$modules[1]['subwidth'] = "95%";
				break;
			default:

				$width1 = round(99.6/($cols-0.1), 2);
				$width2 = round((99.6 - $width1*($cols-2))/2, 2);

				for ($i=1; $i<$cols - 1; $i++){
					$modules[$i]['class'] = "-center";
					$modules[$i]['width'] = $width1."%";
					$modules[$i]['subwidth'] = "90%";
				}
				$modules[0]['class'] = "-left";
				$modules[0]['width'] = $width2."%";
				$modules[0]['subwidth'] = "95%";
				$modules[$cols - 1]['class'] = "-right";
				$modules[$cols - 1]['width'] = $width2."%";
				$modules[$cols - 1]['subwidth'] = "95%";
				break;
		}
		return $modules;
	}

	function getNews($catid, $numrows=4) {
		global  $mainframe, $now, $access;

		$database 	=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$nullDate 	= $database->getNullDate();
		$noauth 	= !$mainframe->getCfg( 'shownoauth' );
		$aid=$user->get('aid',0);
		// query to determine article count
		$query = "SELECT a.id,a.sectionid, a.introtext, a.fulltext , a.images, a.attribs, a.title, a.state,"
		.' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'
		.' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'
		."\n FROM #__content AS a"
		."\n INNER JOIN #__categories AS cc ON cc.id = a.catid"
		."\n INNER JOIN #__sections AS s ON s.id = a.sectionid"
		."\n WHERE a.state = 1"
		. ( $noauth ? "\n AND a.access <= " . (int) $aid . " AND cc.access <= " . (int) $aid . " AND s.access <= " . (int) $aid : '' )
		."\n AND (a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= NOW() ) "
		."\n AND (a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= NOW() )"
		."\n AND a.catid = " . (int) $catid
		."\n AND cc.published = 1"
		."\n AND s.published = 1"
		."\n ORDER BY a.ordering"
		."\n LIMIT 0, $numrows"
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		return $rows;
	}
}
?>